import 'package:flutter/foundation.dart';

// Package imports:
import 'package:zego_plugin_adapter/zego_plugin_adapter.dart';

// Project imports:
import 'package:zego_uikit/src/plugins/signaling/impl/core/core.dart';

/// @nodoc
mixin ZegoPluginNotificationService {
  /// enable notification
  Future<ZegoSignalingPluginEnableNotifyResult>
      enableNotifyWhenAppRunningInBackgroundOrQuit(
    bool enabled, {
    bool? isIOSSandboxEnvironment,
    bool enableIOSVoIP = true,
    int /*ZegoSignalingPluginMultiCertificate*/ certificateIndex = 1,
    String appName = '',
    String androidChannelID = '',
    String androidChannelName = '',
    String androidSound = '',
  }) {
    return ZegoSignalingPluginCore.shared.coreData
        .enableNotifyWhenAppRunningInBackgroundOrQuit(
      enabled,
      isIOSSandboxEnvironment: isIOSSandboxEnvironment,
      certificateIndex: ZegoSignalingPluginIOSMultiCertificateExtension.fromID(
        certificateIndex,
      ),
      enableIOSVoIP: enableIOSVoIP,
      appName: appName,
      androidChannelID: androidChannelID,
      androidChannelName: androidChannelName,
      androidSound: androidSound,
    );
  }

  Future<void> addLocalNotification(
    ZegoSignalingPluginOutgoingNotificationConfig config,
  ) async {
    return ZegoSignalingPluginCore.shared.coreData.addLocalNotification(config);
  }

  Future<void> createNotificationChannel(
    ZegoSignalingPluginOutgoingNotificationChannelConfig config,
  ) async {
    return ZegoSignalingPluginCore.shared.coreData.createNotificationChannel(
      config,
    );
  }

  Future<void> dismissAllNotifications() async {
    return ZegoSignalingPluginCore.shared.coreData.dismissAllNotifications();
  }

  Future<void> activeAppToForeground() async {
    return ZegoSignalingPluginCore.shared.coreData.activeAppToForeground();
  }

  Future<void> requestDismissKeyguard() async {
    return ZegoSignalingPluginCore.shared.coreData.requestDismissKeyguard();
  }
}
